from flask import Flask,jsonify, g
from sqlalchemy import create_engine
from flask import Blueprint
from LMSAPI.api.Views.TokenAPI import auth
from LMSAPI.api.Models.Division import Division
from flask_cors import CORS

division_api = Blueprint('division_api', __name__)

CORS(division_api)

@division_api.route('/lms/api/v1.0/<lname>/divisions_list', methods=['GET'])
# @auth.login_required
def getActiveDivisions(lname):
    divisionList = Division().getActiveDivisions(lname)
    
    if divisionList is None:
        return jsonify(success=False),404

    return jsonify(divisionList)


@division_api.route('/lms/api/v1.0/<lname>/divisions', methods=['GET'])
@auth.login_required
def getDivisions(lname):
    admin_flag = g.user.access_modes["Справочники"]["Постоянный состав. Администратор"] in ["Полный"]
    if admin_flag:
        divisionList = Division().getDivisionList(lname)
    else:
        divisionList = Division().getAllowedDivisionList(lname, g.user.mid)

    if divisionList is None:
        return jsonify(success=False), 404

    return jsonify(divisionList)
