INSERT INTO course_tema_detail(course_tema_plan,id_curriculum_course_details,hours,eventtool,in_session)
SELECT 
  p.id,
  d.id_curriculum_course_details,
  coalesce(d.interm_test, round(d.test* case coalesce(ps.education_level,1) when 1 then coalesce(clm.intensity_unit_hrs,q.intensity_unit_hrs,36) else 1 end)),  
  case d.oid 
    when -1 then (select coalesce((select min(typeid) from eventtools where trmtid=8),49))
    when -2 then (select coalesce((select min(typeid) from eventtools where trmtid=7),74))
    when -3 then (select coalesce((select min(typeid) from eventtools where trmtid=9),54))
    when -4 then (select coalesce((select min(typeid) from eventtools where trmtid=10),104))
  end etype, 
  (coalesce(d.interm_test, 0) > 0)::int
FROM curriculum_course_details d
JOIN curriculum_course cc ON (cc.id_curriculum_course = d.id_curriculum_course)
JOIN curriculum_detail cd ON cd.id_curr_detail=cc.id_curr_detail  JOIN curriculum clm ON clm.idcurriculum=cd.idcurriculum 
JOIN  qualif_demands q on q.q_demand_id=clm.q_demand_id  JOIN militaryprofession mp ON mp.mpid=q.mpid 
JOIN edu_direction ed ON ed.edu_direct_id=mp.edu_direct_id  JOIN preparation_structure ps ON ps.ps_id=ed.program_level 
LEFT JOIN organizations o ON (o.oid = d.oid)
JOIN termslist tl ON tl.tlid = d.tlid
left join eventtools_exams ee on ee.eeid = d.oid
left join course_tema_plan p ON p.id_curriculum_course = cc.id_curriculum_course
left join course_tema_detail ctd on ctd.id_curriculum_course_details = d.id_curriculum_course_details and ctd.course_tema_plan = p.id
WHERE d.oid < 0  and ctd.id is null and p.id is not null
ORDER BY cc.id_curriculum_course;

UPDATE curriculum 
SET status = 0
WHERE confirm_date IS NULL;
  
UPDATE curriculum 
SET status = 1
WHERE confirm_date IS NOT NULL; 

UPDATE curriculum 
SET status = 2
WHERE close_date IS NOT NULL;



DELETE FROM training_facilites_object_bases
WHERE standard_type IS NOT NULL;

do $$
declare maxid int;
begin
select coalesce(max(tfobid),0)+1 INTO maxId from training_facilites_object_bases;
execute 'ALTER SEQUENCE IF EXISTS training_facilites_object_bases_tfobid_seq
RESTART WITH ' || maxId;
end;
$$ language plpgsql;

INSERT INTO training_facilites_object_bases (title, standard_type)
VALUES 
('База для выполнения научных исследований', 5),
('Вооружение и военная техника', 1),
('База для общевоенной и физической подготовки', 6),
('База и средства информационного обеспечения', 7),
('Учебно-лабораторная база', 2),
('Тренажерная база', 3),
('Полевая учебная база', 4),
('Объекты обеспечения учебного процесса', 8);

DELETE FROM training_facilites_object_types
WHERE standard_type IS NOT NULL;

do $$
declare maxid int;
begin
select coalesce(max(tfotid),0)+1 INTO maxId from training_facilites_object_types;
execute 'ALTER SEQUENCE IF EXISTS training_facilites_object_types_tfotid_seq
RESTART WITH ' || maxId;
end;
$$ language plpgsql;

INSERT INTO training_facilites_object_types (title, standard_type, tfobid)
VALUES
('Учебные здания (корпуса) и сооружения', 201, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 2)),
('Полигоны', 401, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 4)),
('Объекты, оборудованные и оснащенные в соответствии с характером и видом выполняемой научной (исследовательской) деятельности', 501, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 5)),
('Строевые плацы', 601, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 6)),
('караульные комплексы (городки)', 602, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 6)),
('Клуб', 701, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 7)),
('опытные заводы', 801, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 8)),
('учебно-производственные мастерские', 802, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 8)),
('склады', 803, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 8)),
('другие объекты', 804, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 8));

DELETE FROM roomtypes
WHERE standard_type IS NOT NULL;

do $$
declare maxid int;
begin
select coalesce(max(rtid),0)+1 INTO maxId from roomtypes;
execute 'ALTER SEQUENCE IF EXISTS roomtypes_rtid_seq
RESTART WITH ' || maxId;
end;
$$ language plpgsql;

INSERT INTO roomtypes(name, standard_type, tfobid)
VALUES
('лекционные залы', 1, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 2)),
('специализированные классы, кабинеты лаборатории', 2, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 2)),
('классы для самостоятельной подготовки', 3, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 2)),
('залы для курсового и дипломного проектирования', 4, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 2)),
('клиники (поликлиники)', 5, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 2)),
('классы с техническими средствами обучения и контроля', 6, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 2)),
('классы с ПЭВМ', 7, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 2)),
('лингафонные классы', 8, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 2)),
('другие учебные и учебно-вспомогательные помещения', 9, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 2)),
('учебно-тренировочные и эксплуатационные комплексы и системы современных образцов вооружения и военной техники', 1, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 3)),
('учебные командные пункты и учебные пункты управления', 2, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 3)),
('тренажерные классы, оснащенные тренажерами, учебным вооружением военной (специальной) техникой', 3, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 3)),
('войсковое стрельбище', 1, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 4)),
('учебные центры', 10, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 4)),
('лагеря с размещенными на них объектами (комплексами) боевой подготовки', 11, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 4)),
('директрисса', 2, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 4)),
('танкодром', 3, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 4)),
('автодром', 4, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 4)),
('машинодром', 5, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 4)),
('аэродром', 6, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 4)),
('акватория', 7, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 4)),
('шлюпочная база', 8, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 4)),
('парашютно-десантные горки', 9, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 4)),
('объекты, оборудованные и оснащенные в соответствии с характером и видом выполняемой научной (исследовательской) деятельности', 1, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 5)),
('строевые плацы', 1, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 6)),
('караульные комплексы (городки)', 2, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 6)),
('тиры', 3, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 6)),
('бассейны', 4, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 6)),
('спортивные комплексы и сооружения', 5, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 6)),
('спортивные залы', 6, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 6)),
('спортивные залы, оборудованные спортивным инвентарем', 7, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 6)),
('Клуб', 1, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 7)),
('библиотека', 2, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 7)),
('читальные залы', 3, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 7)),
('типография', 4, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 7)),
('опытные заводы', 1, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 8)),
('учебно-производственные мастерские', 2, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 8)),
('склады', 3, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 8)),
('другие объекты', 4, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 8));

DELETE FROM equip_type
WHERE standard_type IS NOT NULL;

do $$
declare maxid int;
begin
select coalesce(max(id),0)+1 INTO maxId from equip_type;
execute 'ALTER SEQUENCE IF EXISTS equip_type_id_seq
RESTART WITH ' || maxId;
end;
$$ language plpgsql;

INSERT INTO equip_type(name, standard_type, tfobid)
VALUES
('Вооружение и военная (специальная) техника, стоящие на вооружении ВС РФ и подлежащие изучению (освоению) и (или) используемые в процессе обучения ', 1, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 1)),
('интерактивные доски', 2, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 7)),
('документ-камеры', 3, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 7)),
('Проекторы', 1, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 7)),
('другие мультимедийные средства', 4, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 7)),
('тренажеры-образцы современного (новейшего) вооружения и военной (специальной) техники', 1, (SELECT tfobid FROM training_facilites_object_bases WHERE standard_type = 3));
